package vismon.data;

import vismon.gui.Vismon;
import vismon.util.Computations;
import vismon.util.Constants;
import vismon.util.Util;

import java.awt.Color;
import java.util.*;

public class Scenario extends DataItem {
    
    public static int indicatorCounter;

    private String name;
    private Color color;
    private boolean visible;



    static {
        indicatorCounter = 1;
    }

    public Scenario(MngAction action) {
        super(action);

        name = "Scn" + indicatorCounter;
        color = Constants.getScenarioColor();
        visible = true;

        //++indicatorCounter;

        checkIfFiltered();
    }

    public void checkIfFiltered() {
        //TODO
    }

    public static void incrementIndicatorCounter() {
        if (indicatorCounter == 1)
            Vismon.getVismonInstance().setTradeoffsWinMenuItemSelected();
        ++indicatorCounter;
    }

    public Color getColor() {
        return color;
    }

    public void setColor(Color color) {
        this.color = color;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public boolean isVisible() {
        return visible;
    }

    public void setVisible(boolean visible) {
        this.visible = visible;
    }

    public double getAverageOrMedianValue(Indicator indicator, int avgMedian) {
        if (avgMedian == 0)
            return getAverageValue(indicator);
        return getMedianValue(indicator);
    }

    public void computeSimValues() {
        MngOption xMngOption = Session.getMngOption(0);
        MngOption yMngOption = Session.getMngOption(1);

        for (Indicator ind : Session.getIndicators()) {
            List<Double> simValues = Computations.getSimValuesOfPoint(xMngOption, yMngOption, ind,
                    mngAction.getMngValue(xMngOption), mngAction.getMngValue(yMngOption));
            for (int i = 0; i < simValues.size(); ++i)
                addValue(i, ind, simValues.get(i));
        }
    }

    public boolean lessThan(Scenario scenario, Indicator indicator) {
        return (getAverageValue(indicator) <= scenario.getAverageValue(indicator));
    }

    @Override
    public boolean equals(Object o) {
        Scenario oScenario = (Scenario)o;
        return  name.equals(oScenario.getName()) &&
                color.equals(oScenario.getColor()) &&
                Util.equals(mngAction.getMngValue(Session.getMngOption(0)), (oScenario.getMngAction().getMngValue(Session.getMngOption(0)))) &&
                Util.equals(mngAction.getMngValue(Session.getMngOption(1)), (oScenario.getMngAction().getMngValue(Session.getMngOption(1))));
    }

    @Override
    public String toString() {
        return name + ": \t@(" + mngAction.getMngValue(Session.getMngOption(0)) +
                mngAction.getMngValue(Session.getMngOption(1)) + ")" +
                "\n\t" + color;
    }
}
